Page MenuHomePhabricator

OSPF max-metric values over 100 cause commit errors
Closed, ResolvedPublicBUG

Description

We upgraded a system from 1.1.8 to 1.2-epa3 and stumpled over the following problem.
Our OSPF configuration had the following sub feature active:

...
 max-metric {
     router-lsa {
         on-shutdown 600
         on-startup 600
     }
 }
...

The config system had no issues but the commit throws and error.

Regards
Markus

Details

Difficulty level
Easy (less than an hour)
Version
VyOS 1.2.0-epa3
Why the issue appeared?
Issues in third-party code
Is it a breaking change?
Perfectly compatible

Event Timeline

adestis created this task.Jan 28 2019, 1:07 PM
syncer changed the task status from Open to In progress.Feb 5 2019, 2:16 PM
syncer assigned this task to zsdc.
syncer triaged this task as Normal priority.
syncer edited projects, added VyOS 1.2 Crux (VyOS 1.2.1); removed VyOS 1.2 Crux.
syncer moved this task from Need Triage to Backlog on the VyOS 1.2 Crux board.
pasik added a subscriber: pasik.Feb 5 2019, 7:44 PM
zsdc changed the task status from In progress to Confirmed.Feb 7 2019, 5:53 PM
zsdc reassigned this task from zsdc to dmbaturin.
zsdc added subscribers: dmbaturin, zsdc.

Hello, @adestis!
You can use values from 5 to 100. 600 is unsupported in current FRRouting.

@dmbaturin if we can do this, we need to add input check for this property.

Hi zsdc,

I was not aware that there are other limits now.
The limit should be displyed during configuration and the right error should be displayed.

Regards
Markus

dmbaturin set Is it a breaking change? to Perfectly compatible.
dmbaturin closed this task as Resolved.Sep 1 2019, 8:55 PM

As a stopgap measure that allows old config to load, I've made the script cap it at 100:

vyos@vyos-test-2# set protocols ospf max-metric router-lsa on-startup 300
[edit]
vyos@vyos-test-2# set protocols ospf max-metric router-lsa on-shutdown 800
[edit]
vyos@vyos-test-2# commit
[ protocols ospf max-metric router-lsa on-shutdown 800 ]
Warning: 800 is not a supported value for OSPF max-metric, reducing to 100

[ protocols ospf max-metric router-lsa on-startup 300 ]
Warning: 300 is not a supported value for OSPF max-metric, reducing to 100

[edit]
vyos@vyos-test-2# vtysh -c 'sh run' | grep max-metric
 max-metric router-lsa on-startup 100
 max-metric router-lsa on-shutdown 100
[edit]

For 1.3.0, we should consider changing the validation rules and adding a migration script, but in an LTS release, breaking old syntax is unacceptable.

dmbaturin renamed this task from OSPF max-metric configuration not supported to OSPF max-metric values over 100 cause commit errors.Sep 1 2019, 8:56 PM
dmbaturin removed a project: VyOS 1.3 Equuleus.
dmbaturin changed Difficulty level from Unknown (require assessment) to Easy (less than an hour).
dmbaturin changed Why the issue appeared? from Will be filled on close to Issues in third-party code.